
Redmine - Defect #8411

Can't remove "Project" column on custom query

2011-05-20 10:40 - Simon Edwards

Status: Closed Start date: 2011-05-20

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category: Issues Estimated time: 0.00 hour

Target version: 1.2.2   

Resolution: Fixed Affected version: 1.2.0

Description

If I create a custom query for issues, and remove the "Project" column from display (for example, if I'm using it as a "Group By"

instead), it returns as soon as I apply or save the query.

This appears to be because this is considered to be the "default columns" - if you do this with a saved query, after saving the query,

the "Default columns" checkbox is ticked when you go back and edit it.

One solution is to add another column, or change the order, but it's not obvious - a couple of users have tried to create the exact

same query and got this result.

It appears to affect all versions but I'm running 1.1.2

To reproduce:

1. Go to /issues

2. Click "Clear" to make sure you're looking at the default view

3. Click "Options"

4. Remove the "Project" column from the right-hand box

5. Click apply - the column is not removed

To work-around:

Repeat steps 1-4, but then move one of the displayed columns up or down before clicking apply.

I couldn't find any similar reports, but I realise that this may be a duplicate. Also, I'm not sure "Issues" is the correct category.

Associated revisions

Revision 6099 - 2011-06-20 03:09 - Jean-Baptiste Barth

Added a test to ensure 'Project' column can be removed on issues list (#8411)

Revision 7538 - 2011-09-26 19:44 - Etienne Massip

Allow project column to be removed from the global issue list columns (#8411).

Revision 7539 - 2011-09-26 19:47 - Etienne Massip

Merged r7538 from trunk (#8411).

History

#1 - 2011-05-20 14:43 - Etienne Massip

- Target version set to Candidate for next minor release

Confirmed.

#2 - 2011-06-20 03:33 - Jean-Baptiste Barth

- Status changed from New to Closed

- Target version changed from Candidate for next minor release to 1.2.1

- % Done changed from 0 to 100
- Resolution set to Fixed

Doesn't seem to occur anymore, tested on current trunk and on 1.2.0-stable. I presume it's fixed because now filters, sort options and columns are

kept in the URL. Anyway I completed the tests in r6099 to be sure it doesn't happen again. Thanks for reporting (and confirming).

#3 - 2011-06-20 08:51 - Etienne Massip

- Status changed from Closed to Reopened

Nope, I confirmed I saw it on 1.2 trunk, will test again.

#4 - 2011-06-20 21:42 - Jean-Baptiste Barth

Ok, if you manage to reproduce, can you run the test and tell me if it's relevant ? Maybe it's more complicated...

#5 - 2011-06-20 23:05 - Etienne Massip

Just reproduced on demo site which runs on 1.2.0 following the above instructions step by step, did you try with /issues or /projectX/issues ?

Did not take time to run the test, will try to do it tomorrow.

#6 - 2011-06-20 23:05 - Etienne Massip

- Resolution deleted (Fixed)

#7 - 2011-06-20 23:05 - Etienne Massip

- Affected version (unused) changed from 1.1.2 to 1.2.0

- Affected version changed from 1.1.2 to 1.2.0

#8 - 2011-06-22 10:13 - Etienne Massip

Still not ran the test (will do !) but find the bug at source:trunk/app/models/query.rb#L347 :

# Set column_names to nil if default columns

if names.map(&:to_s) == Setting.issue_list_default_columns

  names = nil

end

The test is incomplete for /issues if you remove the Project column from the list since :

the names method argument will match the default column list

:column_names attribute will be set to nil

#has_default_columns? will return true

#columns will return default column list and project column

Will look for a fix later.

#9 - 2011-06-22 12:20 - Etienne Massip

- File default_columns.patch added

Here's a patch.

I didn't test it in all situations, didn't run the test suite neither.

Also, I guess there's room for nicer code in #default_column.

#10 - 2011-06-22 17:17 - Etienne Massip

E.g., replacing :

column_index = available_columns.index(column)

# Adds the project column by default for cross-project lists

if project.nil? && !project_column_included && column_index > project_column_index

 by :

# Adds the project column by default for cross-project lists

if project.nil? && !project_column_included && available_columns.index(column) > project_column_index

 would perform faster.
#11 - 2011-06-22 17:23 - Etienne Massip

- File default_columns.patch added

Updated patch

#12 - 2011-06-22 17:29 - Etienne Massip

And your test pass since the specified columns are ['tracker', 'subject', 'assigned_to'].

It should not pass with columns = Setting.issue_list_default_columns at start of the test.

#13 - 2011-06-24 09:01 - Etienne Massip

This patch still has some glitches, will update it later.

#14 - 2011-06-25 14:33 - Etienne Massip

- File deleted (default_columns.patch)

#15 - 2011-07-03 12:14 - Jean-Philippe Lang

- Target version changed from 1.2.1 to Candidate for next minor release

#16 - 2011-07-12 19:26 - Etienne Massip

- File query_default_columns.patch added

Last one, simplier is better. Got some issues with my env, so couldn't run tests :/

#17 - 2011-09-26 19:45 - Etienne Massip

- Status changed from Reopened to Resolved

- Target version changed from Candidate for next minor release to 1.2.2

Should be fixed with r7538.

#18 - 2011-09-26 20:06 - Etienne Massip

- Resolution set to Fixed

#19 - 2011-10-26 21:48 - Mischa The Evil

Etienne Massip wrote:

Should be fixed with r7538.

 Confirmed!

#20 - 2011-11-11 12:29 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

default_columns.patch 1.86 KB 2011-06-22 Etienne Massip

query_default_columns.patch 1.44 KB 2011-07-12 Etienne Massip
